// CP Domination (Points) Prefab
// by Sarexicus

::points <- [];
last_tick <- Time();
pd_logic <- Entities.FindByClassname(null, "tf_logic_player_destruction");
EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", 0.0, null, null);

::CPCaptured <- function(index, team) {
    points[index] = team;
}

function Score() {
    foreach (point in points) {
        if(point == 0) continue;
        EntFireByHandle(pd_logic, point == 2 ? "ScoreRedPoints" : "ScoreBluePoints", "", 0, null, null);
    }
}

function Think() {
    if(Time() - last_tick > 1.0) {
        Score();
        last_tick = Time();
    }
}

local ent = null;
local i = 0;
while(ent = Entities.FindByClassname(ent, "trigger_capture_area")) {
    EntityOutputs.AddOutput(ent, "OnCapTeam1", "!self", "RunScriptCode", "CPCaptured(" + i.tostring() + ", 2)", 0.1, -1);
    EntityOutputs.AddOutput(ent, "OnCapTeam2", "!self", "RunScriptCode", "CPCaptured(" + i.tostring() + ", 3)", 0.1, -1);
    points.push(0);
    i += 1;
}
